require ('run')
my = require ('my')

local lk = love.keyboard
--local time = love.timer.getTime()
local last_draw = love.timer.getTime()
local last_update = love.timer.getTime()
local UPS = 0
--local ticksPerSecond, tick = 0, 0
local xpos, ypos = 0, 60
--local lastdt
local width, height = love.graphics.getDimensions( )

local u = 0
local d = 0
local max_speed = 100

function move_cursor (dt)
	if lk.isDown("left") then
        xpos = xpos - dt*max_speed
		if xpos < 0 then xpos = 0 end
    elseif lk.isDown("right") then
        xpos = xpos + dt*max_speed
		if xpos > (width-10) then xpos = (width-10) end
	end
    if lk.isDown("up") then
        ypos = ypos - dt*max_speed
		if ypos < 60 then ypos = 60 end
    elseif lk.isDown("down") then
        ypos = ypos + dt*max_speed
		if ypos > (height-10) then ypos = (height-10) end
    end
end


function update_bar (bar)
	if bar.y == 0 then
		bar.x = bar.x + 1
		if bar.x == width then bar.y = bar.y + 1 end
	elseif bar.x == width then
		bar.y = bar.y + 1
		if bar.y == height then bar.x = bar.x - 1 end
	elseif bar.y == height then
		bar.x = bar.x - 1
		if bar.x == 0 then bar.y = bar.y - 1 end
	else
		bar.y = bar.y - 1
		if bar.x == 0 and bar.y == 0 then
			return true
		end
	end
end

love.load = function()
	sliders = {ups = {x=100, y=32, w=608, h=15, slider_x = 104}}
	
	bar = {xc=width/2, yc=height/2, x=0, y=0, color = {1, 1, 1}}
	bar2 = {xc=width/2, yc=height/2, x=0, y=0, color = {1, 1, 0}}
	
	--	local nn = {}

	local layers = 
	{
	  {name = 'input', values={0.5, -0.4, 0.3, 0.9}},
	  {name = 'first-hidden', size = 3, values={}},
	  {name = 'output', size = 2, values={}},
	}
	layers[1].size = #layers[1].values -- size = 4

	-- update
	for n_layer = 2, #layers do
	  local layer = layers[n_layer]
	  local prev_layer = layers[n_layer-1]
	  layer.nods = layer.nods or {}
	  for n_nod = 1, layer.size do
		layer.nods[n_nod] = layer.nods[n_nod] or {}
		local nod = layer.nods[n_nod]
		nod.bias = nod.bias or math.random(-100, 100)/100
		local summ = nod.bias
		for n_synaps = 1, prev_layer.size do
		  nod[n_synaps] = nod[n_synaps] or math.random(-100, 100)/100
		  local weight = nod[n_synaps]
		  local input = prev_layer.values[n_synaps]
		  summ = summ + weight*input
		end
		local activated = (summ > 0) and summ or 0 -- ReLU
		layer.values[n_nod] = activated
	  end
	end
	
	love.timer.t_sleep = 0

	print (unpack(layers[#layers].values))
end


love.update = function(dt)
    local now = love.timer.getTime()
	UPS = 1/(now-last_update) -- seconds per update to  per seconds
	u = u + 1
	move_cursor (dt)
	last_update = now
	
	local slider_name, n_value, value = my.clicked_slider(sliders)
	if slider_name then
--		print ('value: ' .. value)
--		love.timer.t_sleep = (value^3/(600*600))/6000
		love.timer.t_sleep = (value/600)^3*15/(1000)
	end
	
	if update_bar (bar) then
		update_bar (bar2)
	end
end


love.draw = function(dt)
	d = d + 1
	
    local gr = love.graphics
    local y = 70
	
	gr.print(string.format("Updates %d", u), 0, y)
    y = y + gr.getFont():getHeight()
	
	gr.print(string.format("Frames %d", d), 0, y)
    y = y + gr.getFont():getHeight()

	gr.print(string.format("UPS %d", love.timer.ups), 0, y)
    y = y + gr.getFont():getHeight()
	
    gr.print(string.format("FPS %d", love.timer.fps), 0, y) -- seconds per frame to frame per seconds
	
--    y = y + gr.getFont():getHeight()
--    gr.print(string.format("FPS %d", love.timer.getFPS()), 0, y)
--    y = y + gr.getFont():getHeight()
--    gr.print(string.format("dt = %f", lastdt), 0, y)
--    y = y + gr.getFont():getHeight()
--    gr.print(string.format("updates per second %d", ticksPerSecond), 0, y)

	love.graphics.setColor({0,1,0})
    gr.rectangle("fill", xpos, ypos, 10, 10)
	
	my.draw_sliders (sliders)
	
	love.graphics.setColor(bar.color)
	love.graphics.line( bar.xc, bar.yc, bar.x, bar.y)
	
	love.graphics.setColor(bar2.color)
	love.graphics.line( bar2.xc, bar2.yc, bar2.x, bar2.y)
end