function love.run()
	if love.load then 
		love.load(love.arg.parseGameArguments(arg), arg) 
	end

	-- We don't want the first frame's dt to include time taken by love.load.
	if love.timer then love.timer.step() end
	love.timer.sleep_t = love.timer.sleep_t or 0
	love.timer.ups = 60
	love.timer.fps = 60

	local udt = 0 -- update time, up to 300k UPS
	local fdt = 0 -- render time, up to 60 FPS
	
	local target_ups = 300000
	local target_fps = 60 -- max 60

	-- Main loop time.
	return function()
		
		-- Process events
		if love.event then
			love.event.pump()
			for name, a,b,c,d,e,f in love.event.poll() do
				if name == "quit" then
					if not love.quit or not love.quit() then
						return a or 0
					end
				end
				love.handlers[name](a,b,c,d,e,f)
			end
		end
		
		-- Update dt, as we'll be passing it to update
		local dt = love.timer.step()
		
		-- Call update
		udt = udt + dt
		local p = love.timer.t_sleep
		if (udt-p) >= (1/target_ups) then
			if love.update then love.update(udt) end -- will pass 0 if love.timer is disabled
			love.timer.ups = 1/udt
			udt = 0
		else 
			love.timer.sleep((1/target_ups)-(udt))
		end

		-- Call and draw
		fdt = fdt + dt
		
		if fdt >= (1/target_fps) then
			if love.graphics and love.graphics.isActive() then
				love.graphics.origin()
				love.graphics.clear(love.graphics.getBackgroundColor())
				if love.draw then love.draw() end
				love.graphics.present()
			end
			love.timer.fps = 1/fdt
			fdt = 0
		end

--		if love.timer then
--			local t_sleep = love.timer.t_sleep or 0.001
--			love.timer.sleep(t_sleep) 
--		end
	end
end